<template>
  <nav>
    <template v-if="$store.state.access">
      <button @click="logout()" class="button is-danger">Log out</button> |
    </template>

    <template v-else>
      <router-link to="/sign-up">Sign Up</router-link> |
      <router-link to="/log-in">Log In</router-link>
    </template>
  </nav>
  <router-view />
</template>

<script>
import axios from 'axios';

export default {
  name: 'App',
  beforeCreate() {
    this.$store.commit("initializeStore")

    const access = this.$store.state.access

    if (access) {
      axios.defaults.headers.common['Authorization'] = " JWT " + access
    } else {
      axios.defaults.headers.common['Authorization'] = ''
      this.$router.push('/log-in')
    }
  },
  methods: {
    logout() {
      axios.defaults.headers.common["Authorization"] = ""
      localStorage.removeItem("access")
      localStorage.removeItem("username")
      localStorage.removeItem("userid")
      this.$store.commit('setAccess', false)
      this.$router.push('/log-in')
    },
  }
}
</script>

<style lang="scss">
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}

nav {
  padding: 30px;

  a {
    font-weight: bold;
    color: #2c3e50;

    &.router-link-exact-active {
      color: #42b983;
    }
  }
}
</style>
